//***PIC16F628***
//Clock 4Mhz
//Compiler mikroC 5.0
//Describtion: Test Software UART with PORTA
//Send  "Hello world" to Software UART Port
//and Echo when receive char
//   RX RA1(PIN-18)
//   TX RA0(PIN-17)

//Send C-String with NULL-Terminate
void TxStrSw(char *Str)
{
int i;
    i=0;
    while(Str[i]!=0)
    {
     Soft_UART_Write(Str[i]);
     i++;
    }
}

unsigned short RxBuff,RcvOK;
char Msg[]="Hello world \r\n\x0";
void main()
{
    CMCON=7;                                //Set PORTA is digital output

//initialize Soft UART(8 bit, 9600 baud rate, no parity bit...
    Soft_Uart_Init(PORTA, 1, 0, 9600, 0);
//Send Message
    TxStrSw(Msg);

    while (1)
    {
     do
     {
      RxBuff = Soft_Uart_Read(&RcvOK);         // receive RxBuff
     } while (RcvOK);

    Soft_UART_Write(RxBuff);                  // send RxBuff via UART
    }
}
